#ifndef GSFIX_SETJMP_H
#define GSFIX_SETJMP_H

#include <setjmp.h>

typedef struct {
  char c;
  jmp_buf j;
} gsfix_jmp_buf_test;

#define gsfix_jmp_buf_align ((size_t)&((gsfix_jmp_buf_test*)0)->j)

typedef struct {
  unsigned char stuff[sizeof(jmp_buf) + gsfix_jmp_buf_align];
} gsfix_jmp_buf;

#define gsfix_orig_jmp_buf      jmp_buf
#define gsfix_orig_setjmp(x)    setjmp(x)
#define gsfix_orig_longjmp(x,y) longjmp((x),(y))

#undef jmp_buf
#undef setjmp
#undef longjmp

#define jmp_buf        gsfix_jmp_buf
#define setjmp(x)      (gsfix_orig_setjmp(find_jmp_buf((x))))
#define longjmp(x,val) (gsfix_orig_longjmp(find_jmp_buf((x)),(val)))

#define find_jmp_buf(gsfjb) 				\
  (							\
   ((size_t)(gsfjb).stuff + gsfix_jmp_buf_align) 	\
   & ~(size_t)(gsfix_jmp_buf_align-1)			\
  )

#endif /*GSFIX_SETJMP_H*/
